import * as React from "react";
import { CenterContent, CenterBoth, MarginClass, PaddingClass, BgColorClass, FgColorClass } from "./../../utilities/uiHelpers";
export interface IGrid extends React.Props<Grid>, React.HTMLProps<Grid> {
    debugMode?: boolean;
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
    table?: boolean;
    fillContainer?: boolean;
}
export declare class Grid extends React.Component<IGrid, any> {
    render(): JSX.Element;
}
export interface IColRow extends IRow {
    centerContent?: CenterContent | CenterBoth;
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
}
export interface IRow extends React.HTMLProps<Row> {
    fixed?: boolean | number;
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
    maxCols?: number;
}
export declare class Row extends React.Component<IRow, any> {
    render(): JSX.Element;
}
export interface ICol extends React.HTMLProps<Col> {
    centerContent?: CenterContent | CenterBoth;
    spans?: number;
    fixed?: boolean | number;
    className?: string | MarginClass | PaddingClass | BgColorClass | FgColorClass;
}
export declare class Col extends React.Component<ICol, {}> {
    render(): JSX.Element;
}
export declare class SingleColumnRow extends React.Component<IColRow, any> {
    render(): JSX.Element;
}
export declare class FixedCentralColumnRow extends React.Component<IColRow, any> {
    render(): JSX.Element;
}
